(ns pulsar-test.core
  (:refer-clojure :exclude [await])
  (:require [co.paralleluniverse.pulsar.core :refer [await]]
            [co.paralleluniverse.pulsar.actors :refer :all]))

(defn test-async-func
  [callback]
  (throw (Exception. "Blah"))
  (callback :blah))

(defn test-gen-server
  [name]
  (gen-server
   (reify Server
     (init [_]
       (println "Starting Server...")
       (throw (Exception. "Blah"))
       (register! name @self)
       (println "Started Server."))
     (terminate [_ cause]
       (println "Stopping Server...")
       (unregister! @self)
       (println "Stopped Server."))
     (handle-call [_ from id [command param]]
       ))))

(defn run-server
  []
  (spawn (test-gen-server "test/test-server")))


(defn run-server-via-supervisor
  []
  (spawn
   (supervisor "entry-point" :one-for-one
               (fn []
                 [["test/test-server" :permanent 20 5 :sec 100
                   (test-gen-server "test/test-server")]]))))
